from django.apps.registry import apps
from m3 import plugins

from django.conf import urls
from django.conf.urls import url
from kinder.controllers import dict_controller

from concentrator.changes.actions import ChangesDetailPack
from concentrator.changes.actions import ChangesPack
from concentrator.dict import signals
from concentrator.dict.actions import ServicesPack
from concentrator.update_conf.actions import UpdateConfigPack
import concentrator.changes.app_meta


def register_actions():
    """
    Метод регистрации Action'ов для приложения в котором описан
    """

    dict_controller.packs.extend([
        UpdateConfigPack(),
        ChangesDetailPack(),
        ChangesPack(),
        ServicesPack()
    ])


def register_extensions():
    """Регистрация точек расширения"""

    if apps.is_installed('kinder.plugins.message_exchange'):
        from concentrator.extensions import handle_text_message_response
        from concentrator.extensions import get_text_message_event_builder
        from concentrator.extensions import validate_text_message_response

        plugins.ExtensionManager().register_point(plugins.ExtensionPoint(
            name='concentrator.extensions.get_text_message_event_builder',
            default_listener=plugins.ExtensionHandler(
                handler=get_text_message_event_builder)))

        plugins.ExtensionManager().register_point(plugins.ExtensionPoint(
            name='concentrator.extensions.handle_text_message_response',
            default_listener=plugins.ExtensionHandler(
                handler=handle_text_message_response)))

        plugins.ExtensionManager().register_point(plugins.ExtensionPoint(
            name='concentrator.extensions.validate_text_message_response',
            default_listener=plugins.ExtensionHandler(
                handler=validate_text_message_response)))
