from m3.plugins import ExtensionHandler
from m3.plugins import ExtensionManager
from m3.plugins import ExtensionPoint

from concentrator.smev3_v321.esnsi.actions import ClassifierListPack
from concentrator.smev3_v321.esnsi.actions import ClassifierUpdatePack
from kinder.urls import dict_controller
from .extensions import add_applicant_answer_column
from .extensions import add_applicant_answer_column_filter
from .extensions import add_applicant_answer_data
from .extensions import applicant_answer_update_filter_list
from .extensions import apply_applicant_answer_filter


def register_extensions():
    """Регистрация точек расширения плагина"""

    ExtensionManager().register_point(ExtensionPoint(
        name='concentrator.smev3_v321.extensions.add_applicant_answer_column',
        default_listener=ExtensionHandler(handler=add_applicant_answer_column)
    ))

    ExtensionManager().register_point(ExtensionPoint(
        name='concentrator.smev3_v321.extensions.add_applicant_answer_data',
        default_listener=ExtensionHandler(handler=add_applicant_answer_data)
    ))

    ExtensionManager().register_point(ExtensionPoint(
        name='concentrator.smev3_v321.extensions.'
             'add_applicant_answer_column_filter',
        default_listener=ExtensionHandler(
            handler=add_applicant_answer_column_filter)
    ))

    ExtensionManager().register_point(ExtensionPoint(
        name='concentrator.smev3_v321.extensions.apply_applicant_answer_filter',
        default_listener=ExtensionHandler(
            handler=apply_applicant_answer_filter)
    ))

    ExtensionManager().register_point(ExtensionPoint(
        name='concentrator.smev3_v321.extensions.'
             'applicant_answer_update_filter_list',
        default_listener=ExtensionHandler(
            handler=applicant_answer_update_filter_list)
    ))

def register_actions():

    dict_controller.packs.extend([
        ClassifierListPack(),
        ClassifierUpdatePack()
    ])
